% example usage

% see celltrack function for settings specified by voxagarsettings (line
cellprops = celltrack('voxagarsettings');

% to track using only x-y coordinates
cellprops = performhginttracking(cellprops,[],80,0.8,0.02,100,NaN,NaN);
tracks = goodftracks(cellprops,5);

% alternatively, track using x-y and intensities
usexy = field2val2(cellprops,'nucxy');
gfp = field2val2(cellprops,'nucgfp');
rfp = field2val2(cellprops,'nucsumint')./field2val2(cellprops,'nucarea');
coords = [usexy(:,[1,2]),gfp,rfp];

cellprops = performhginttracking(cellprops,coords,80,0.8,0.02,100,[],[]); % track using default intensity weighting functions
tracks = goodftracks(cellprops,5);

% example extraction of spot intensity for tracked cells
% subfillint is the method used to calculate spot intensity
spotint = props2tracks(cellprops,tracks,'spotprops.subfillint');

