function fim = adimfilter(im,nhood)

if islogical(im)
    im = double(im);
end

if (numel(nhood)==2 || numel(nhood)==3 || numel(nhood)==4) && ~islogical(nhood)
    % cuboidal neighbourhood, separable into 1D filters for speed.
    fim1 = imfilter(im,ones(nhood(1),1)/nhood(1),'symmetric','same');
    
    fim = imfilter(fim1,ones(1,nhood(2))/nhood(2),'symmetric','same');
    if numel(nhood)>2
        fim = imfilter(fim,ones(1,1,nhood(3))/nhood(3),'symmetric','same');
        
        if numel(nhood)>3
            fim = imfilter(fim,ones(1,1,1,nhood(4))/nhood(4),'symmetric','same');
            
            if numel(nhood)>4
                fim = imfilter(fim,ones(1,1,1,1,nhood(5))/nhood(5),'symmetric','same');
            end
        end
    end
else
    fim = imfilter(im,nhood/nnz(nhood),'symmetric','same');
    
end