function [rout,g,b] = adind2rgb(x,cm,stretch,nointerp)

% my implementation of the colormap conversion, which uses interpolation to
% find the colour values

if nargin<4 || isempty(nointerp)
    nointerp = 0;
end
if nargin<3 || isempty(stretch)
    stretch = 1; % by default, stretch the colors to the limits of x
end

if ischar(cm)
    cm = eval([cm, '(255)']);
end

% if we're not stretching, then cm should really be specified explicity by
% the user
if stretch
    x = 1 + (size(cm,1)-1)*normalise(x);
end

% should be able to do this without interpolating if speed becomes an issue
if nointerp
    x = round(x); % should work whether stretching or not
    temp = cm(:,1);
    rout = temp(x);
    temp = cm(:,2);
    g = temp(x);
    temp = cm(:,3);
    b = temp(x);
else
    rout = reshape(interp1q((1:size(cm,1))',cm(:,1),x(:)),size(x));
    g = reshape(interp1q((1:size(cm,1))',cm(:,2),x(:)),size(x));
    b = reshape(interp1q((1:size(cm,1))',cm(:,3),x(:)),size(x));
end

if nargout<2
    ndim = numel(size(rout));
    rout = cat(ndim+1,rout,g,b);
end


