function dd = discel(r,binary,siz)

% Makes a 2D circular filter of radius r.  Like the 2-D disk filter
% function, this uses fractional values for pixels which lie on the edge of
% the filter.

if nargin<2
    binary = 0;
end

if length(r)==1
	r = [1 1]*r;
end

if nargin<3
    dd = zeros(round(6*(r(1)+0.5)),round(6*(r(2)+0.5)));
    midp = 0.5 + 3*(r+0.5);
else
    dd = zeros(3*siz);
    midp = ceil((3*siz+1)/2)*[1 1];
end

[x,y] = makegrid2(dd);

dd(((x-midp(1))/(3*r(1))).^2 + ((y-midp(2))/(3*r(2))).^2 < 1) = 1;

dd = imshrink(dd,3,'mean');

if binary
    dd = dd>0.5;
else   
    dd = dd/sum(dd(:));
end