function imout = dog3filt(im,fi)

% Custom written filtering for the DoG filter, fi, which has been split
% into 1D positive and negative components.

% fi.x1 is the positive (narrower) Gaussian
% fi.x2 is the negative (wider) Gaussian

% Check the speeds later, but for now permute the filter rather than the
% image for y and z.

% On first inspection, this seems to work exactly the same as the 3d version using
% convn.m, but is much faster and also doesn't suffer as much from edge
% effects.

% the output image seems to have switched the x and y axes?

if ~isa(im,'double')
	im = double(im);
end

imf1 = imfilter(im,fi.x1,'replicate');
imf1 = imfilter(imf1,permute(fi.y1,[2 1]),'replicate');
imf1 = imfilter(imf1,permute(fi.z1,[2 3 1]),'replicate');

imf2 = imfilter(im,fi.x2,'replicate');
imf2 = imfilter(imf2,permute(fi.y2,[2 1]),'replicate');
imf2 = imfilter(imf2,permute(fi.z2,[2 3 1]),'replicate');

imout = imf1 - imf2;


