function fi = dog3split2(width,siz,factor)

% splitting the DoG filter into
% positive and negative parts, then decomposing into 1D filters.

if length(width)==1
	width = [1 1 1]*width;
end

if nargin<3 || isempty(factor)
	factor = 1.6;
end
if nargin<2 || isempty(siz)
	siz = odd(7*width);
end

siz = odd(siz,'up');

if isscalar(siz)
    siz = [1 1 1]*siz;
end


n = (0.55:0.1:(siz(1)+0.45))';
m = (1+siz(1))/2;
width2 = factor*width(1);

% a more accurate representation of narrow kernels would be to sum up a
% bunch of values to approximate an integral

temp1 = (2*pi*width(1)^2)^(-1/2) * exp(-((n-m).^2)/(2*width(1)^2));
temp2 = (2*pi*width2^2)^(-1/2) * exp(-((n-m).^2)/(2*width2^2));

fi.x1 = sum(reshape(temp1,[10,numel(temp1)/10])',2);
fi.x2 = sum(reshape(temp2,[10,numel(temp1)/10])',2);

n = (0.55:0.1:(siz(2)+0.45))';
m = (1+siz(2))/2;
width2 = factor*width(2);

temp1 = (2*pi*width(2)^2)^(-1/2) * exp(-((n-m).^2)/(2*width(2)^2));
temp2 = (2*pi*width2^2)^(-1/2) * exp(-((n-m).^2)/(2*width2^2));

fi.y1 = sum(reshape(temp1,[10,numel(temp1)/10])',2);
fi.y2 = sum(reshape(temp2,[10,numel(temp1)/10])',2);

n = (0.55:0.1:(siz(3)+0.45))';
m = (1+siz(3))/2;
width2 = factor*width(3);

temp1 = (2*pi*width(3)^2)^(-1/2) * exp(-((n-m).^2)/(2*width(3)^2));
temp2 = (2*pi*width2^2)^(-1/2) * exp(-((n-m).^2)/(2*width2^2));

fi.z1 = sum(reshape(temp1,[10,numel(temp1)/10])',2);
fi.z2 = sum(reshape(temp2,[10,numel(temp1)/10])',2);


fi.x1 = fi.x1/sum(fi.x1);
fi.y1 = fi.y1/sum(fi.y1);
fi.z1 = fi.z1/sum(fi.z1);
fi.x2 = fi.x2/sum(fi.x2);
fi.y2 = fi.y2/sum(fi.y2);
fi.z2 = fi.z2/sum(fi.z2);
  