function val = field2val(indices,arg)

if isempty(indices)
    val = [];
    return
end

if nargin<2
    % reverse the order of structure and array, so that the output is a
    % structure of arrays rather than an array of structures.
    fnames = fieldnames(indices);
    for ii = 1:length(fnames)
        for jj = 1:length(indices(:))
            temp(jj,:) = indices(jj).(fnames{ii});
        end
%         temp = reshape(temp,size(indices)); % in case indices is an array
        val.(fnames{ii}) = squeeze(reshape(temp,[size(indices) size(temp,2)]));
        clear temp
    end
else
    if ischar(arg)
        fnames{1} = arg;
    elseif isnumeric(arg)
        ftemp = fieldnames(indices);
        for ii = 1:length(arg)
            fnames{ii} = ftemp{arg(ii)};
        end
    else
        % should be a cell already
        fnames = arg;
    end
    for ii = 1:length(fnames)
        % the size of temp needs to be set up using the first non-empty
        % index.
        temp = [];
        for jj = 1:length(indices(:))
            if ~isempty(indices(jj).(fnames{ii}))
                temp = zeros(length(indices(:)),length(indices(jj).(fnames{ii})));
                break
            end
        end
        if isempty(temp)
            temp = 1;
        end
        for jj = 1:length(indices(:))
            if ~isempty(indices(jj).(fnames{ii}))
                try
                    temp(jj,:) = reshape(indices(jj).(fnames{ii}),[1 size(temp,2)]);
                catch
                    [];
                end
            else
                temp(jj,:) = NaN*ones([1 size(temp,2)]);
            end
        end
        try
            val.(fnames{ii}) = squeeze(reshape(temp,[size(indices) size(temp,2)]));
            % this can go wrong if only one index is found, fix it in the
            % next line.
            if size(indices,1)==1
                val.(fnames{ii}) = (val.(fnames{ii}))';
            end
        catch
            warning('Spindle3D:fields','Reshaping has gone wrong - tell Adam');
        end
    end
    if length(fnames)==1
        try
            val = val.(fnames{1});
        catch
            warning('Spindle3D:fields','Something went wrong with the field extraction, returning empty variable')
            val = [];
        end
    end
end
    

