function varargout = findthresh(varargin)
% FINDTHRESH M-file for findthresh.fig
%      FINDTHRESH, by itself, creates a new FINDTHRESH or raises the existing
%      singleton*.
%
%      H = FINDTHRESH returns the handle to a new FINDTHRESH or the handle to
%      the existing singleton*.
%
%      FINDTHRESH('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FINDTHRESH.M with the given input arguments.
%
%      FINDTHRESH('Property','Value',...) creates a new FINDTHRESH or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before findthresh_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to findthresh_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help findthresh

% Last Modified by GUIDE v2.5 08-Oct-2009 11:45:26

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @findthresh_OpeningFcn, ...
                   'gui_OutputFcn',  @findthresh_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before findthresh is made visible.
function findthresh_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to findthresh (see VARARGIN)

% Choose default command line output for findthresh
handles.output = hObject;

handles.im = varargin{1};
if length(varargin)>1
    handles.im2 = varargin{2};
    if length(varargin)>2
        set(hObject, 'Name', varargin{3});
    end
else
    handles.im2 = handles.im;
end

if max(handles.im(:)) > 1 || any(handles.im(:)<0)
    handles.minval = min(handles.im(:));
    handles.maxval = max(handles.im(:));
	handles.im = normalise(handles.im);
else
    handles.minval = 0;
    handles.maxval = 1;
end
if max(handles.im2(:)) > 1 || any(handles.im2(:)<0)
    handles.im2 = normalise(handles.im2);
end

handles.immax = max(handles.im(:));
handles.immin = min(handles.im(:));

if size(handles.im,3)>1
    handles.im = max(handles.im,[],3);
end
if size(handles.im2,3)>1
    handles.im2 = max(handles.im2,[],3);
end

if numel(varargin)<4 || isempty(varargin{4})
    handles.thresh = 0.5*(handles.immax + handles.immin);
else
    handles.thresh = min(max(varargin{4},handles.immin),handles.immax);
end
% Initial value for the threshold

handles.thrim = handles.im > handles.thresh;

handles.blend = 0.5;
set(handles.slider2,'Value',handles.blend)

warp((1-handles.blend)*handles.thrim + handles.blend*handles.im2)

set(handles.slider1,'min',handles.immin,'max',handles.immax,'value',handles.thresh)
set(handles.text1,'String',num2str(handles.thresh,'%5.2d'))

% Update handles structure
guidata(hObject, handles);

% Make the GUI modal
set(handles.figure1,'WindowStyle','modal')

% UIWAIT makes param_gui wait for user response (see UIRESUME)
% uiwait(handles.figure1);

uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = findthresh_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
% guidata(hObject,handles)
varargout{1} = handles.minval + handles.thresh*(handles.maxval-handles.minval);

% The figure can be deleted now
delete(handles.figure1);


% --- Executes on slider movement.
function slider1_Callback(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

set(handles.togglebutton1,'string','Thresholded','Value',1)

handles.thresh = get(hObject,'Value');

set(handles.text1,'String',num2str(handles.minval + handles.thresh*(handles.maxval-handles.minval),'%5.2d'))

handles.thrim = handles.im > handles.thresh;

warp((1-handles.blend)*handles.thrim + handles.blend*handles.im2)

% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function slider1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on button press in togglebutton1.
function togglebutton1_Callback(hObject, eventdata, handles)
% hObject    handle to togglebutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of togglebutton1

handles.blend = 1 - round(handles.blend);
set(handles.slider2,'Value',handles.blend)

warp((1-handles.blend)*handles.thrim + handles.blend*handles.im2)

% Update handles structure
guidata(hObject, handles);


% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

guidata(gcbf,handles)

if isequal(get(handles.figure1, 'waitstatus'), 'waiting')
    % The GUI is still in UIWAIT, us UIRESUME
    uiresume(handles.figure1);
else
    % The GUI is no longer waiting, just close it
    delete(handles.figure1);
end


% --- Executes on slider movement.
function slider2_Callback(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

handles.blend = get(hObject,'Value');

warp((1-handles.blend)*handles.thrim + handles.blend*handles.im2)

% Update handles structure
guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function slider2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


