function [fname,ind_v1,ind] = firstmatch(fnames,choices)

% function has been improved to get the case of the fieldname correct;
% keep ind_v1 as the second output for the purposes of backwards
% compatibility

ind = NaN;

if ~iscell(fnames)
    fnames = fieldnames(fnames);
end
if ~iscell(choices)
    choices = {choices};
end

for ii = 1:numel(choices)
    isMatch = strcmpi(fnames,choices{ii});
    
    if sum(isMatch)>0
        ind = find(isMatch,1,'first');
        ind_v1 = ii;
        break
    end
end

if ~isnan(ind)
    % rather than using the choices, it's better to using the fieldnames
    % directly to get the case right
    fname = fnames{ind};
else
    fname = '';
end

