function outprop = frametracks(trackprops,prop)

% get the track properties in array form, but synchronize in absolute time
% rather than track starting points.

if ischar(prop)
    prop = permute(field2val2(trackprops,prop),[2,1,3]);
end

if isstruct(trackprops)
    tf = field2val2(trackprops,'frames')';
else
    tf = trackprops;
end

nf = max(tf(:));

outprop = NaN*zeros(nf,size(tf,2),size(prop,3));

for ii = 1:size(tf,2)
    inds = tf(:,ii)>0;
%     for jj = 1:size(prop,3)
        outprop(tf(inds,ii),ii,:) = prop(inds,ii,:);
%     end
    
end
