function imf1 = gauss3filt(im,fi,boundcon)

% Custom written filtering for a 3D Gaussian filter, fi, which has been split
% into 1D positive and negative components.

% fi.x1 is the positive Gaussian

% Check the speeds later, but for now permute the filter rather than the
% image for y and z.

% On first inspection, this seems to work exactly the same as the 3d version using
% convn.m, but is much faster and also doesn't suffer as much from edge
% effects.

% the output image seems to have switched the x and y axes?

if nargin<3 || isempty(boundcon)
    boundcon = 'replicate';
end

if ~isstruct(fi)
    fi = dog3split(fi,4*fi);
end

if ~isa(im,'double')
	im = double(im);
end

% % % what's quicker, permuting the image and filtering along x?
% % imf1 = imfilter(im,fi.x1,boundcon);
% % imf1 = imfilter(imf1,permute(fi.y1,[2 1]),boundcon);
% % imf1 = imfilter(imf1,permute(fi.z1,[2 3 1]),boundcon);
% % % 
% % % imf2 = imfilter(im,fi.x2,'replicate');
% % % imf2 = imfilter(imf2,permute(fi.y2,[2 1]),'replicate');
% % % imf2 = imfilter(imf2,permute(fi.z2,[2 3 1]),'replicate');
% % 
% % % imout = imf1 - imf2;


imf1 = imfilter(permute(im,[3,1,2]),fi.z1,boundcon);
imf1 = imfilter(permute(imf1,[3,1,2]),fi.y1,boundcon);
imf1 = imfilter(permute(imf1,[3,1,2]),fi.x1,boundcon);

