function imreg = getimreg(im,xyz,cropsiz)

if nargin<3 || isempty(cropsiz)
    cropsiz = [3 3 3];
end

xyz = round(xyz);

if size(xyz,1)>1
    % call recursively and put in a cell array.
    % Now that the sizes are consistent, no need to use a cell array..
    imreg = cell(size(xyz,1),1);
    for ii = 1:size(xyz,1)
        imreg{ii} = getimreg(im,xyz(ii,:),cropsiz);
    end
else
%     if size(im,3)>1
        if numel(cropsiz)<3
            cropsiz(3) = 1;
        end
        if size(xyz,2)<3
            xyz(3) = 1;
        end
        imsiz = size(im);
        if numel(imsiz)<3
            imsiz(3) = 1;
        end
        imreg = NaN*ones(cropsiz);
        
        % find the image limits to use
        xmin = round(max(1,min(imsiz(1),xyz(1)-(cropsiz(1)-1)/2)));
        xmax = round(max(1,min(imsiz(1),xyz(1)+(cropsiz(1)-1)/2)));
        
        ymin = round(max(1,min(imsiz(2),xyz(2)-(cropsiz(2)-1)/2)));
        ymax = round(max(1,min(imsiz(2),xyz(2)+(cropsiz(2)-1)/2)));
        
        zmin = round(max(1,min(imsiz(3),xyz(3)-(cropsiz(3)-1)/2)));
        zmax = round(max(1,min(imsiz(3),xyz(3)+(cropsiz(3)-1)/2)));
        
        
        % now find where this will go in the crop so that the point of
        % interest is in the middle
        xc1 = (cropsiz(1)+1)/2 - xyz(1) + xmin;
        yc1 = (cropsiz(2)+1)/2 - xyz(2) + ymin;
        zc1 = (cropsiz(3)+1)/2 - xyz(3) + zmin;
        
        % have everything we need
        try
        imreg(xc1:(xc1+xmax-xmin),yc1:(yc1+ymax-ymin),zc1:(zc1+zmax-zmin)) = ...
            im(xmin:xmax,ymin:ymax,zmin:zmax);
        catch ME
            rethrow(ME)
        end
        
%     else
%         
%     end
end