function varargout = imgray(im,cmap)

if size(im,3)>1
    im = permute(imresize(permute(im,[1 3 2]),...
            [size(im,1) 3],'bilinear'),[1 3 2]);
end

inds = ~isfinite(im);
if nnz(inds)>0
    im(inds) = NaN;
end

if nargin<2 || isempty(cmap)
    h = imshow(mat2gray(im));
else
    % colour maps will only work with 2D images
    im = max(im,[],3);
    
    h = imshow(adind2rgb(im,cmap,1));
end


if nargout==1
    varargout{1} = h;
end