function imsmall = imshrink(imin,factor,method,arg)

if nargin<2 || isempty(factor)
	factor=2;
end
factor = floor(factor);

if nargin<3
	method = 'max';
end

if strcmpi(method,'index') && nargin<4
	arg = 1;
end

imsize = size(imin);
ndim = length(imsize);

if length(factor)==1
	factor = factor*ones(size(imsize));
end

factor = factor(1:length(imsize));

newsize = floor(imsize./factor);
switch ndim
	case 2
		imin = imin(1:(newsize(1)*factor(1)),1:(newsize(2)*(factor(2))));
	case 3
		imin = imin(1:(newsize(1)*factor(1)),1:(newsize(2)*(factor(2))),1:(newsize(3)*factor(3)));
end

imtemp = zeros([newsize prod(factor)]);
% make a temporary image with an extra dimension to then take the maximum
% over.  I wonder if there's some clever way of reshaping the original
% image this way..

switch ndim
	case 2
		for ii = 1:factor(1)
			for jj = 1:factor(2)
				imtemp(:,:,(factor(2)*(ii-1) + jj)) = imin(ii:factor(1):end,jj:factor(2):end);
			end
		end
	case 3
		for ii = 1:factor(1)
			for jj = 1:factor(2)
				for kk = 1:factor(3)
					imtemp(:,:,:,kk + factor(3)*(jj-1) + factor(3)*factor(2)*(ii-1)) ...
						= imin(ii:factor(1):end,jj:factor(2):end,kk:factor(3):end);
				end
			end
		end
	case 4
		% Do this when necessary..
end

switch method
	case 'max'
		imsmall = max(imtemp,[],ndim+1);
	case 'min'
		imsmall = min(imtemp,[],ndim+1);
	case {'mean','average'}
		imsmall = mean(imtemp,ndim+1);
	case 'index'
        switch ndim
			case 2
				imsmall = imtemp(:,:,arg);
			case 3
				imsmall = imtemp(:,:,:,arg);
        end
    case 'median'
        imsmall = median(imtemp,ndim+1);
end


