function xval = nearestmaxfit1(x,y,xi,order)

% find the nearest maximum to the user specified xi, and find the position
% to subpixel accuracy

y = y(:);
x = x(:);

if nargin<4 || isempty(order)
    order = 3;
end
if nargin<3 || isempty(xi) || isnan(xi)
    xi = find(y==max(y));
    if length(xi)>1
        useable = find(xi~=1 && xi~=length(y));
        if isempty(useable)
            xi = xi(1);
        else
            xi = xi(useable(1));
        end
    end
end

maxinds = find(y>[y(2:end);-Inf] & y>[-Inf;y(1:(end-1))]);

% find the nearest to the specified position
xdist = abs(x-xi);
xind = find(xdist(maxinds)==min(xdist(maxinds)));

% if more than one, pick the highest
if numel(xind)>1
    best = find(y(maxinds(xind))==max(y(maxinds(xind))),1,'first');
    xind = xind(best);
end

ind = maxinds(xind);

% % % if ind==1 || ind==length(y)
% % %     xval = x(ind);
% % % else

% % %     useinds = [ind(1)-1 ind(1) ind(1)+1];
% % % 
% % %     xinc = x(2) - x(1);
% % %     % uniformly spaced for now
% % % 
% % %     fx = (y(useinds(3)) - y(useinds(1)))/(2*xinc);
% % %     fxx = (y(useinds(1)) - 2*y(useinds(2)) + y(useinds(3)))/(xinc^2);
% % %     xval = x(ind(1)) - fx/fxx;
    
    switch order
        case 1
            % Simple maximum finding
            xtemp = x(ind);
            xval = xtemp(1);
        case 3
            % 3 points
%             ind = find(ff==max(ff));
            useinds = 1 + mod([ind(1)-2 ind(1)-1 ind(1)] , length(x));
            xinc = x(2) - x(1);
            fx = (y(useinds(3)) - y(useinds(1)))/(2*xinc);
            fxx = (y(useinds(1)) - 2*y(useinds(2)) + y(useinds(3)))/(xinc^2);
            xval = x(ind(1)) - fx/fxx;
        case 5
            % 5 points
%             ind = find(ff==max(ff));
            useinds = 1 + mod([ind(1)-3 ind(1)-2 ind(1)-1 ind(1) ind(1)+1] , length(x));
            xinc = x(2) - x(1);
            fx = (y(useinds(1)) - 8*y(useinds(2)) + 8*y(useinds(4)) - y(useinds(5)))/(12*xinc);
            fxx = (-y(useinds(1)) + 16*y(useinds(2)) - 30*y(useinds(3)) ...
                + 16*y(useinds(4)) - y(useinds(5)))/(12*xinc^2);
            xval = x(ind(1)) - fx/fxx;
    end
% % % end

