function imthin = nonmaxsupp2(imx,imy,thresh)

img = sqrt(imx.^2 + imy.^2);
imphi = atan2(imy,imx);

gmax = max(img(:));
img = img/gmax;

[xdim,ydim] = size(img);

if nargin<3
	thresh = 0.5;
end

% Put a ring of zeros around the whole gradient image, to avoid the problem
% of looking at pixels outside the image when doing the non-maximum
% suppression.

img2 = zeros(xdim+2, ydim+2);
img2(2:(end-1),2:(end-1)) = img;

inds = findn(img>thresh);

for ii = 1:length(inds(:,1))
	roundimphi = round(4/pi*imphi(inds(ii,1),inds(ii,2)));

	checkpix = round([cos(pi/4*roundimphi) , sin(pi/4*roundimphi)]);
 
	% checkpix specifies which pixels need checking depending depending on the
	% gradient direction.
	
	if (img(inds(ii,1),inds(ii,2)) < img2(inds(ii,1)+checkpix(1)+1,inds(ii,2)+checkpix(2)+1) ...
			 || img(inds(ii,1),inds(ii,2)) < img2(inds(ii,1)-checkpix(1)+1,inds(ii,2)-checkpix(2)+1)) ...
			 || img(inds(ii,1),inds(ii,2)) < thresh

		% The edge is not a maximum in the direction of the gradient, so
		% get rid of it.

		img(inds(ii,1),inds(ii,2)) = 0;
	end
end

%imthin = (img>thresh);
% Generate a binary image of the remaining maximal edges

imthin = img;

