function subpeak = pivsubpix3(imreg)

subpeak = zeros(size(imreg,4),3);

sizreg = size(imreg);
if numel(sizreg)<4
    sizreg((numel(sizreg)+1):4) = 1;
end

% implement my own version of this ASAP
% doing the logs means that everything has to be positive..

for ii = 1:size(imreg,4)
    treg = imreg(:,:,:,ii);
    lreg = log(treg - min(treg(:)) + 0.2*adstd(treg(:)));
    xyz = findn(treg==max(treg(:)));
    % just take the first?
    xyz = xyz(1,:);

    p0 = lreg(xyz(1),xyz(2),xyz(3));

    if xyz(1)>1 && xyz(1)<size(treg,1)
        pxd = lreg(xyz(1)-1,xyz(2),xyz(3));
        pxu = lreg(xyz(1)+1,xyz(2),xyz(3));
        delta(1) = (pxd-pxu)/(2*pxd-4*p0+2*pxu);
    else
        delta(1) = 0;
    end

    if xyz(2)>1 && xyz(2)<size(treg,2)
        pyd = lreg(xyz(1),xyz(2)-1,xyz(3));
        pyu = lreg(xyz(1),xyz(2)+1,xyz(3));
        delta(2) = (pyd-pyu)/(2*pyd-4*p0+2*pyu);
    else
        delta(2) = 0;
    end

    if xyz(3)>1 && xyz(3)<size(treg,3)
        pzd = lreg(xyz(1),xyz(2),xyz(3)-1);
        pzu = lreg(xyz(1),xyz(2),xyz(3)+1);
        delta(3) = (pzd-pzu)/(2*pzd-4*p0+2*pzu);
    else
        delta(3) = 0;
    end

    delta(delta>0.5) = 0.5;
    delta(delta<-0.5) = -0.5;
    
    subpeak(ii,:) = xyz + delta - (sizreg(1:3) + 1)/2;
end

% for our PIV measurements, the whole 