function imstack = readstackbeta(varargin)

% mess about with optional inputs later, but just get a working version
% running first

% new version which takes parameter value pairs

% default settings
type = '*';
label = [];
folderpath = cd;
sfactor = 1;
method = [];
zslice = 'all';
pixreg = [];

for ii = 1:2:length(varargin)
    switch lower(varargin{ii})
        case 'type'
            type = varargin{ii+1};
        case 'label'
            label = varargin{ii+1};
        case {'fpath','folderpath'}
            folderpath = varargin{ii+1};
        case {'sfactor','crop'}
            sfactor = varargin{ii+1};
        case 'method'
            method = varargin{ii+1};
        case {'zslice','zslices','slices','indices','slice'}
            zslice = varargin{ii+1};
        case 'pixreg'
            pixreg = varargin{ii+1};
    end
end

if isempty(method)
    if numel(sfactor)>3
        method = 'crop';
    elseif max(sfactor)>1
        method = 'scale';
    else
        method = 'none';
    end
end

names = ['*' label '*.' type];

currdir = cd;

if ~strcmpi(folderpath,currdir)
    cd(folderpath)
end

imagelist = dir(names);
imstack = [];


% remove anything with a dot at the start of the name
rem = false(numel(imagelist),1);
for ii = 1:numel(imagelist)
    [pointless,temp] = fileattrib(imagelist(ii).name);
    rem(ii) = temp.hidden;
end
imagelist(rem) = [];

if ~isempty(imagelist)
	zdim = length(imagelist);
    if ischar(zslice)
        if strcmpi(zslice,'all')
            zslice = 1:zdim;
        end
    end
    
    zslice(zslice>zdim) = [];
    
    if ~isempty(pixreg)
        testim = imread(imagelist(zslice(1)).name,'pixelregion',pixreg);
    else
        testim = imread(imagelist(zslice(1)).name);
    end
    if size(testim,3)>1
% 		testim = rgb2gray(testim);
		testim = max(testim,[],3);
		colors = 1;
	else
		colors = 0;
    end
    switch method
        case 'scale'
            testim = imshrink(testim,sfactor,'mean');
        case 'crop'
            testim = cropim(testim,sfactor(1,:),sfactor(2,:));
    end
    
	[xdim,ydim] = size(testim);
	imstack = zeros(xdim,ydim,length(zslice));
	imstack(:,:,1) = testim;
	
	if ~colors
		for ii = 2:length(zslice)
            % this bit could be improved by putting the testim inside the
            % switch statement?
			testim = imread(imagelist(zslice(ii)).name);
            switch method
                case 'scale'
                    imstack(:,:,ii) = imshrink(testim,sfactor,'mean');
                case 'crop'
                    imstack(:,:,ii) = cropim(testim,sfactor(1,:),sfactor(2,:));
                case 'none'
                    imstack(:,:,ii) = testim;
            end
		end
	else
		for ii = 2:length(zslice)
			testim = max(imread(imagelist(zslice(ii)).name),[],3);
            switch method
                case 'scale'
                    imstack(:,:,ii) = imshrink(testim,sfactor,'mean');
                case 'crop'
                    imstack(:,:,ii) = cropim(testim,sfactor(1,:),sfactor(2,:));
                case 'none'
                    imstack(:,:,ii) = testim;
            end
		end
	end
end

if ~strcmpi(currdir,folderpath)
    cd(currdir)
end


