function newfv = removemeshnans(fv)

% remove any vertices with NaNs in, and also any faces which refer to these
% indices, and rescale the face indices accordingly

f = fv.faces;
v = fv.vertices;

nanvlog = isnan(sum(v,2));
% these are the vertices which need removing

nanflog = sum(nanvlog(f),2)>0;
% faces which need removing

keepvs = find(~nanvlog);
keepoldfaces = f(~nanflog,:);

tempoldv = zeros(size(v));
tempoldv(keepvs) = (1:numel(keepvs))';
newfv.faces = tempoldv(keepoldfaces);
newfv.vertices = v(keepvs,:);
