function smoothpovrayexport(Lcell,Lnuc,tempcellprops)

gfp = field2val2(tempcellprops,'nucgfp')';

gfp(isnan(gfp)) = min(gfp);

csvwrite('cellints.csv',gfp)

cellsurf = sum(Lcell>0,3);
cs2 = imclose(cellsurf,ones(2));

kcs2 = cs2;
cs2(isnan(cs2)) = 0;

blcs2 = gauss2filt(cs2,2.5);

blcs2(kcs2==0) = 0;
blcs2(isnan(kcs2)) = NaN;
% figure
% imgray(blcs2)
cs2 = blcs2;
L2 = max(Lcell,[],3);

[x,y,z] = makegrid2(Lcell);

for ii = 1:max(Lcell(:))
    cstemp = cs2;
    cstemp(imerode(L2~=ii,ones(3))) = NaN;
    fvi(ii) = surf2patch(cstemp);
    fvi(ii) = triangulate(removemeshnans(fvi(ii)));
    fvni(ii) = isosurface(y,x,z-2,Lnuc==ii,0.5);
end
for ii = 1:numel(fvi)
    povrayexport(fvi(ii),['cellobjs[' num2str(ii-1) ']'],['cellmesh' num2str(ii,'%0.3d') '.inc'])
end
for ii = 1:numel(fvi)
    povrayexport(fvni(ii),['nucobjs[' num2str(ii-1) ']'],['nucmesh' num2str(ii,'%0.3d') '.inc'])
end