function newfv = triangulate(fv)

% make a triangular mesh from a mesh of other polygons

[frows,fcols] = size(fv.faces);

if fcols>3
    newfaces = zeros(frows*(fcols-2),3);
    newfaces(:,1) = repmat(fv.faces(:,1),fcols-2,1);
    for k = 2:fcols-1
        newfaces( (1:frows)+frows*(k-2), 2:3) = [fv.faces(:,k) fv.faces(:,k+1)];
    end

    newfv = fv;
    newfv.faces = newfaces;
else
    newfv = fv;
end